// this is called by the java side when a RSS item is clicked and load in the webview
   
var dir;
	
function prepareDate(entry){
    try{
        var d = new Date(entry.date*1000);
        entry.dates = {
            dateStr: d.toDateString(),
            since: formatDate(d)
        };
    }catch(e){
        entry.dates = {
            dateStr: entry.strDate,
            since: ""
        };
    }        
}

function formatDate(d) {
    if(!d){
        return "";
    }        
    var seconds = Math.round((Date.now()-d)/1000);
    if (seconds < 5)
        return " just now";
    if (seconds < 60)
        return seconds + " seconds ago";
    else if (seconds < 1.5*60)
        return "1 minute ago";
    else if (seconds < 60*60)
        return Math.round(seconds/60) + " minutes ago";
    else if (seconds < 1.5*60*60)
        return "1 hour ago";
    else if (seconds < 24*60*60)
        return Math.round(seconds/3600) + " hours ago";
    else if (seconds < 1.5*24*60*60)
        return "1 day ago";
    else if (seconds < 7*24*60*60)
        return Math.round(seconds/86400) + " days ago";
    else if (seconds < 1.5*7*24*60*60)
        return "1 week ago";
    else
        return "";
}

function parseMedia(item, div){
    //console.log('media:'+item.media);
    try{
        if(item.media){
            var mediaGroups = JSON.parse(item.media);
            $.each(mediaGroups, function(i,val){
                //console.log(i + ":"  + val);
                $.each(val.contents, function (k, media){
                    // console.log(media);
                    var medium = media.medium || media.type;                    
                    if(medium != null && medium.indexOf('audio')==0){
                        //console.log('media:'+ media.url);
                        var href = encodeURIComponent(media.url);                        
                        var title = media.title || media.url.split('/').pop();
                        $("<br/><div class='visibo-audio'><img src='audio-icon.png'/><a href='visibo://audio?href="
                            + href + "'>" + title + "</a></div>").appendTo(div);
                    }
                    // how about video?
                });
            });
        }
    }catch (e){
        console.error('Media groups error');        
    }
}
function loadItem() {
    var itemJson = itemBg.getSelectedItem();
    dir = itemBg.getDir();
    
    if(dir == 'rtl'){
    	$(document).attr('dir', 'rtl');
    }
    
    var item = JSON.parse(itemJson);	
    prepareDate(item);
	
	
    $("#item-title").attr('href',item.link);
    $("#item-title").html(item.title);

    var isWideMode = itemBg.isWideMode();
    if(isWideMode){
        $('#swipe').hide();
    }
	
    if(item.dates.dateStr){
    	if(dir=='rtl' || !item.dates.since){
    		// do not use since in RTL or too old
    		$("#item-date").text(item.dates.dateStr);	
    	}else{    		
    		$("#item-date").text(item.dates.dateStr+ '('+ item.dates.since+')');
    	}
    }else
        $("#item-date").hide();
	
    if (item.author)
        $("#item-author").text(item.author);
    else
        $("#item-author").hide();

    $("#item-header").css('background-color', itemBg.getThemeColor());
	
    showContent(item, isWideMode);
    
    $("#item-share-button").click(function() {
    	itemBg.shareItem();
    });
}

function showContent(item, isWideMode){
	
    if(!item.content){
        $('<a/>',{
            href:item.link,
            text:item.link
            }).appendTo($("#item-content"));
        return;
    }
	
    // offline mode, load from cache files
    $("#item-content").html(item.content);
    // handle youtube iframe
    var iframes = $("#item-content").find('iframe');
		
    // iframes of youtube are replace with video thumbnail
    $.each(iframes, function(i,val){
        var iframe = $(val);
        var src = iframe.attr('src');
        var matches = src.match(/http:\/\/www.youtube.com\/embed\/([^?&#"']*)\/?/i);
			
        if (matches) {
            var id = matches[1];
            //console.log(id);
            var thumb = $('<a href="visibo://youtube?id='+id+'"></a>');
            $('<img/>', {
                src:'http://img.youtube.com/vi/' + id + '/0.jpg',
                width: iframe.attr('width') ||420,
                height: iframe.attr('height') || 351
            }).appendTo(thumb);
            iframe.replaceWith(thumb);
        }
    });
	
    // if the image width is too large adjust it
    // Do not use window.innerWidth, it is not accurate	
    
    var images = $("#item-content").find('img');
    
    var displayWidth = itemBg.getWidth();
    var viewWidth = window.devicePixelRatio <= 0 ? displayWidth/1.5: displayWidth/window.devicePixelRatio;
    viewWidth = Math.round(viewWidth*0.9);
	
    // share space with home.html
    if(isWideMode)
        viewWidth -= 420;
    
    $("#item-content").find('img').load(function(){
    	  var img = $(this);
          var w = img.width();
          var h = img.height();
          if(viewWidth > 0 && w > viewWidth){
              var r = (viewWidth)/w;
              img.width(w*r);
              img.height(h*r);
          	// console.log('resize from ' + w + ' to ' + img.width());
          }    	
    });
    
    /*if(images.length > 0){
		
        var displayWidth = itemBg.getWidth();
        var viewWidth = window.devicePixelRatio <= 0 ? displayWidth/1.5: displayWidth/window.devicePixelRatio;
        viewWidth = Math.round(viewWidth*0.9);
		
        // share space with home.html
        if(isWideMode)
            viewWidth -= 420;
	
		//console.log('viewWidth'+viewWidth);
        $.each(images, function(i,val){
            var img = $(val);
            var w = img.width();
            var h = img.height();
            if(viewWidth > 0 && w > viewWidth){
                var r = (viewWidth)/w;
                img.width(w*r);
                img.height(h*r);
            	// console.log('resize from ' + w + ' to ' + img.width());
            }
        });
    }*/	
    $('img').error(function(){
        console.error('Load fail' + $(this).attr('src'));
    });
    // show audio and video
    parseMedia(item, $("#item-content"));
}

$(function() {
    $("#item-content").empty();
    loadItem();
});
